--- ../nagios-3.0.4/xdata/xsddefault.c	2008-02-28 20:27:56.000000000 +0100
+++ xsddefault.c	2008-11-25 15:10:20.000000000 +0100
@@ -674,25 +674,28 @@ int xsddefault_save_status_data(void){
 	fchmod(fd,S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH);
 
 	/* close the temp file */
-	fclose(fp);
-
-	/* move the temp file to the status log (overwrite the old status log) */
-	if(my_rename(temp_file,xsddefault_status_log)){
-
-		/* log an error */
-#ifdef NSCORE
-		logit(NSLOG_RUNTIME_ERROR,TRUE,"Error: Unable to update status data file '%s'!\n",xsddefault_status_log);
-#endif
+	if(fclose(fp)) {
+		logit(NSLOG_RUNTIME_ERROR,TRUE,"Error: Unable to close/save status tempfile: %s", strerror(errno));
+		unlink(temp_file);
 
 		/* free memory */
 		my_free(temp_file);
-
 		return ERROR;
-	        }
+		} 
+	else {
+		/* move the temp file to the status log (overwrite the old status log) */
+		if(my_rename(temp_file,xsddefault_status_log)){
+			/* log an error */
+#ifdef NSCORE
+			logit(NSLOG_RUNTIME_ERROR,TRUE,"Error: Unable to update status data file '%s'!\n",xsddefault_status_log);
+#endif
+			unlink(temp_file);
+			return ERROR;
+			}
+		}
 
 	/* free memory */
 	my_free(temp_file);
-
 	return OK;
         }
 
